/*

ACWraith's Multiple Game Rooms library.

	LICENSE:
		As with all of my libraries, you may use this in any type of project
		whether you make money from it or not unless told otherwise.  My name
		in the credits might be a nice advertisement repay me, but it's not
		required.

This library helps track spectators, those in waiting lists and players in
multiple game rooms.  A framework is provided for managing interfaces.
Procs which will aid in communication are included, but there are no verbs.

Rooms in this library are derived from my People library.  Use of the p_ prefix
should be avoided as that is what I used to provide updates.

////////////////////////////////////////////////////////////////////////////////
p_RoomHandler

	p_AddRoom(p_Room/Room,AutomatedCall=FALSE)
		Adds Room to the handler.
	p_GetRooms()
		Returns a copy of the rooms list.
	p_RemoveRoom(p_Room/Room,AutomatedCall=FALSE)
		Removes Room to the handler.

	p_Find(Person)
		Returns the p_Room that holds Person or null if it doesn't exist.
	p_Move(Person,p_Room/Room,AutomatedCall=FALSE)
		Move Person to Room.  Returns TRUE on success.

	p_GetPeople()
		Returns a list of all players, waiters and spectators in all rooms.
	p_GetPlayers()
		Returns a list of all players in all rooms.
	p_GetSpectators()
		Returns a list of all spectators in all rooms.
	p_GetWaiters()
		Returns a list of all waiters in all rooms.

	p_DisplayRoomsToAll(AutomatedCall=FALSE)
		In theory, this should display any room stats to everyone.
		By default, this does absolutely nothing.
	p_DisplayRoomsToViewer(Viewer)
		In theory, this should display any room stats to Viewer.
		By default, this does absolutely nothing.

	p_OutputAll(Message,Control)
		Outputs to all people in all rooms.
	p_OutputPlayers(Message,Control)
		Outputs to all players in all rooms.
	p_OutputSpectators(Message,Control)
		Outputs to all spectators in all rooms.
	p_OutputWaiters(Message,Control)
		Outputs to all waiters in all rooms.

	p_Reconnected(Person)
		Resets interfaces for reconnecting players.
	p_Disconnected(Person)
		This does absolutely nothing by default.
		Calling it when mobs log out could help with library extensions.

	p_AddInterface(Person)
		This can be defined to add a custom interface.
		Called automatically by p_Reconnected().
		Returns TRUE if Person can use an interface.
	p_RemoveInterface(Person)
		This can be defined to remove a custom interface.
		Returns TRUE if Person can use an interface.

	p_WinsetAll(Control,Params)
		Calls winset(Control,Params) for all people in all rooms.
	p_WinsetPlayers(Control,Params)
		Calls winset(Control,Params) for all players in all rooms.
	p_WinsetSpectators(Control,Params)
		Calls winset(Control,Params) for all spectators in all rooms.
	p_WinsetWaiters(Control,Params)
		Calls winset(Control,Params) for all waiters in all rooms.

////////////////////////////////////////////////////////////////////////////////
p_Room

	A p_Room is a type of p_PeopleHandler.
	Refer to my People library for more details.

	Called by p_RoomHandler.Move()
		p_Enter(Person)
			Returns whether or not Person can enter the room.
			TRUE by default.
		p_Entered(Person,p_Room/OldRoom,AutomatedCall=FALSE)
			Person has entered the room as a spectator.
		p_Exit(Person)
			Returns whether or not Person can exit the room.
			TRUE by default.
		p_Exited(Person,AutomatedCall=FALSE)
			Removes Person from the room's p_people and removes the interface.

	p_AddInterfaceRoom(Person)
		This can be defined to add a custom interface.
		Called automatically by p_Entered().
		Returns TRUE if Person can use an interface.
	p_RemoveInterfaceRoom(Person)
		This can be defined to remove a custom interface.
		Called automatically.  Returns TRUE if Person can use an interface.


*/